//+------------------------------------------------------------------+
//|                                     QQE-Adjustable_multiTF.mq4   |
//|                                      Copyright  2008, GodfreyH  |
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "Copyright  2008, GodfreyH"
#property link   "http://www.forex-tsd.com/indicators-metatrader-4/1077-multi-timeframe-indicators.html"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2
#property indicator_level1 50
#property indicator_color2 Yellow
#property indicator_style2 STYLE_DOT

//---- input parameters

/*
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
*/

extern int TimeFrame=0;
extern int SF = 5; // original 5
extern int RSI_Period = 14; // original 14
extern double DARFACTOR = 4.236; //original 4.236 


double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   
   } 
   IndicatorShortName("QQEA("+SF+","+RSI_Period+","+DARFACTOR+") "+TimeFrameStr);  
   }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF QQE ADJUSTABLE                                                  |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
      
  ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"QQEA",SF,RSI_Period,DARFACTOR,0,y);
  ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"QQEA",SF,RSI_Period,DARFACTOR,1,y);
   
 
   }  
     
//
   
  
  
   return(0);
  }
//+------------------------------------------------------------------+